#include <FK/FK.h>

int main(int argc, char *argv[])
{
	// fkut_SimpleWindowł܂Ƃ߂Ă̂
	Fl_Window		mainWindow(512, 512, "FK TEST");
	fk_Model		camera, lightModel;
	fk_Light		light;
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	// AMJ[\ϐ
	fk_Model	RabbitModel, HeadModel, BodyModel, TailModel, EarModel[2], ArmModel[2], LegModel[2], EyeModel[2];
	fk_Block	Ear, Head, Body, Arm, Leg;
	fk_Sphere	Eye, Tail;
	fk_Block	BackPack, MainWing, TailWing;
	fk_Model	SilhouetteModel, WingModel[2], TailWingModel[2];


	mainWindow.end();
	fk_InitMaterial();

	// ZbeBOJn

	//
	Head.setSize(40.0, 15.0, 20.0);
	Ear.setSize(5.0, 15.0, 10.0);
	Eye.setRadius(2.0);
	Eye.setDivide(2);
	Tail.setRadius(5.0);
	Tail.setDivide(2);

	EyeModel[0].setShape(&Eye);
	EyeModel[0].setMaterial(Red);
	EyeModel[0].glMoveTo(10.0, 0.0, 10.0);
	EyeModel[0].setParent(&HeadModel);
	EyeModel[1].setShape(&Eye);
	EyeModel[1].setMaterial(Red);
	EyeModel[1].glMoveTo(-10.0, 0.0, 10.0);
	EyeModel[1].setParent(&HeadModel);

	EarModel[0].setShape(&Ear);
	EarModel[0].setMaterial(Yellow);
	EarModel[0].glMoveTo(10.0, 15.0, 5.0);
	EarModel[0].setParent(&HeadModel);
	EarModel[1].setShape(&Ear);
	EarModel[1].setMaterial(Yellow);
	EarModel[1].glMoveTo(-10.0, 15.0, 5.0);
	EarModel[1].setParent(&HeadModel);

	HeadModel.setShape(&Head);
	HeadModel.setMaterial(White);
	HeadModel.glMoveTo(0.0, 40.0, 0.0);
	HeadModel.setParent(&RabbitModel);

	//
	Body.setSize(20.0, 20.0, 15.0);
	Arm.setSize(15.0, 5.0, 5.0);
	Leg.setSize(5.0, 20.0, 5.0);

	BodyModel.setShape(&Body);
	BodyModel.setMaterial(Blue);
	BodyModel.glMoveTo(0.0, 20.0, 0.0);

	TailModel.setShape(&Tail);
	TailModel.setMaterial(White);
	TailModel.glMoveTo(0.0, -8.0, -10.0);
	TailModel.setParent(&BodyModel);

	ArmModel[0].setShape(&Arm);
	ArmModel[0].setMaterial(White);
	ArmModel[0].glMoveTo(13.0, 3.0, 0.0);
	ArmModel[0].glAngle(0.0, 0.0, -8.7);
	ArmModel[0].setParent(&BodyModel);
	ArmModel[1].setShape(&Arm);
	ArmModel[1].setMaterial(White);
	ArmModel[1].glMoveTo(-13.0, 3.0, 0.0);
	ArmModel[1].glAngle(0.0, 0.0, 8.7);
	ArmModel[1].setParent(&BodyModel);

	LegModel[0].setShape(&Leg);
	LegModel[0].setMaterial(AshGray);
	LegModel[0].glMoveTo(5.0, -20.0, 0.0);
	LegModel[0].setParent(&BodyModel);
	LegModel[1].setShape(&Leg);
	LegModel[1].setMaterial(AshGray);
	LegModel[1].glMoveTo(-5.0, -20.0, 0.0);
	LegModel[1].setParent(&BodyModel);

	BodyModel.setParent(&RabbitModel);
	RabbitModel.glMoveTo(0.0, 5.0, 0.0);

	// tH[XVGbg
	BackPack.setSize(15.0, 10.0, 10.0);
	MainWing.setSize(40.0, 3.0, 10.0);
	TailWing.setSize(3.0, 25.0, 10.0);

	SilhouetteModel.setShape(&BackPack);
	SilhouetteModel.setMaterial(Red);
	SilhouetteModel.glMoveTo(0.0, 5.0, -15.0);
	SilhouetteModel.setParent(&BodyModel);
	WingModel[0].setShape(&MainWing);
	WingModel[0].setMaterial(Red);
	WingModel[0].glMoveTo(25.0, 5.0, 0.0);
	WingModel[0].setParent(&SilhouetteModel);
	WingModel[1].setShape(&MainWing);
	WingModel[1].setMaterial(Red);
	WingModel[1].glMoveTo(-25.0, 5.0, 0.0);
	WingModel[1].setParent(&SilhouetteModel);
	TailWingModel[0].setShape(&TailWing);
	TailWingModel[0].setMaterial(Red);
	TailWingModel[0].glMoveTo(6.0, -16.0, -2.0);
	TailWingModel[0].setParent(&SilhouetteModel);
	TailWingModel[1].setShape(&TailWing);
	TailWingModel[1].setMaterial(Red);
	TailWingModel[1].glMoveTo(-6.0, -16.0, -2.0);
	TailWingModel[1].setParent(&SilhouetteModel);
	WingModel[0].loRotateWithVec(-25.0, 8.0, -15.0, fk_Z, FK_PI/16.0);
	WingModel[1].loRotateWithVec(25.0, -8.0, 15.0, fk_Z, -FK_PI/16.0);
	TailWingModel[0].loRotateWithVec(-6.0, 12.5, 15.0, fk_X, FK_PI/16.0);
	TailWingModel[1].loRotateWithVec(6.0, -12.5, -15.0, fk_X, FK_PI/16.0);

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// effBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	// AM񃂃fo^
	scene.entryModel(&RabbitModel);
	scene.entryModel(&HeadModel);
	scene.entryModel(&BodyModel);
	scene.entryModel(&TailModel);
	scene.entryModel(&SilhouetteModel);
	for(int i = 0; i < 2; i++){
		scene.entryModel(&EarModel[i]);
		scene.entryModel(&ArmModel[i]);
		scene.entryModel(&LegModel[i]);
		scene.entryModel(&EyeModel[i]);
		scene.entryModel(&WingModel[i]);
		scene.entryModel(&TailWingModel[i]);
	}

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 200.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();

	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		// ̂ Y Sɉ]
		RabbitModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/1000.0);

	}

	return 0;
}
